summaryrefslogtreecommitdiffstats
diff options
context:
space:
mode:
authorCecil Hugh Watson <knoppmyth@gmail.com>2010-09-04 22:58:18 (GMT)
committerCecil Hugh Watson <knoppmyth@gmail.com>2010-09-04 22:58:18 (GMT)
commit947b0a71611be195c3d099bc247d9bdd194467e7 (patch)
tree675d6e52ed56b70d52bc94302854154effad1e9b
parentdc0c8146a39dca5deb78e6afb7a7234de4e1b21e (diff)
downloadlinhes_pkgbuild-947b0a71611be195c3d099bc247d9bdd194467e7.zip
linhes_pkgbuild-947b0a71611be195c3d099bc247d9bdd194467e7.tar.gz
linhes_pkgbuild-947b0a71611be195c3d099bc247d9bdd194467e7.tar.bz2
gcc:Bumped/Updated for LinHES 7.
-rw-r--r--abs/core-testing/gcc/PKGBUILD239
-rw-r--r--abs/core-testing/gcc/gcc-ada.install22
-rw-r--r--abs/core-testing/gcc/gcc-fortran.install18
-rw-r--r--abs/core-testing/gcc/gcc-hash-style-both.patch12
-rw-r--r--abs/core-testing/gcc/gcc-libs.install14
-rw-r--r--abs/core-testing/gcc/gcc.install8
-rw-r--r--abs/core-testing/gcc/r160561.patch64
7 files changed, 319 insertions, 58 deletions
diff --git a/abs/core-testing/gcc/PKGBUILD b/abs/core-testing/gcc/PKGBUILD
index fd796b4..40fd4b6 100644
--- a/abs/core-testing/gcc/PKGBUILD
+++ b/abs/core-testing/gcc/PKGBUILD
@@ -1,81 +1,222 @@
-# $Id: PKGBUILD 25249 2009-01-24 18:28:11Z andyrtr $
+# $Id: PKGBUILD 82472 2010-06-11 13:12:15Z allan $
# Maintainer: Jan de Groot <jgc@archlinux.org>
-# Maintainer: Andreas Radke <andyrtr@archlinux.org>
+# Maintainer: Allan McRae <allan@archlinux.org>
-pkgname=gcc
-pkgver=4.3.3
-pkgrel=1
-#_snapshot=4.3-20080724
+# toolchain build order: linux-api-headers->glibc->binutils->gcc->binutils->glibc
+# NOTE: libtool requires rebuilt with each new gcc version
+
+pkgname=('gcc' 'gcc-libs' 'gcc-fortran' 'gcc-objc' 'gcc-ada')
+pkgver=4.5.0
+pkgrel=6
+_snapshot=4.5-20100610
+_libstdcppmanver=20100312 # Note: check source directory name when updating this
pkgdesc="The GNU Compiler Collection"
-arch=(i686 x86_64)
-license=('GPL' 'LGPL')
-groups=('base-devel')
+arch=('i686' 'x86_64')
+license=('GPL' 'LGPL' 'custom')
url="http://gcc.gnu.org"
-depends=('binutils>=2.19' "gcc-libs>=${pkgver}" 'mpfr>=2.3.1' 'texinfo')
-makedepends=('flex')
-replaces=('gcc-fortran' 'gcc-objc')
-options=('!libtool')
-install=gcc.install
-source=(ftp://gcc.gnu.org/pub/gcc/releases/gcc-${pkgver}/gcc-{core,g++,fortran,objc,java}-${pkgver}.tar.bz2
- #ftp://gcc.gnu.org/pub/gcc/snapshots/${_snapshot}/gcc-{core,g++,fortran,objc,java}-${_snapshot}.tar.bz2
- ftp://gcc.gnu.org/pub/gcc/libstdc++/doxygen/libstdc++-man-20080118.tar.bz2
+makedepends=('binutils>=2.20.1' 'libmpc>=0.8.2-2' 'cloog-ppl>=0.15.8' 'libelf' 'gcc-ada')
+options=('!libtool' '!emptydirs')
+source=(#ftp://gcc.gnu.org/pub/gcc/releases/gcc-${pkgver}/gcc-{core,g++,fortran,objc,ada}-${pkgver}.tar.bz2
+ ftp://gcc.gnu.org/pub/gcc/snapshots/${_snapshot}/gcc-{core,g++,fortran,objc,ada}-${_snapshot}.tar.bz2
+ ftp://gcc.gnu.org/pub/gcc/libstdc++/doxygen/libstdc++-man.${_libstdcppmanver}.tar.bz2
gcc_pure64.patch
gcc-hash-style-both.patch
- buildfix_new_bison.patch)
-md5sums=('1739288c2c7b1472796b33d641dbdbbd'
- '18428e313a9927d38b313e688c62219b'
- '8771e6190dd4f3178b2a7978d2380a5d'
- '125b75947c763ba59b7ea95d3739d431'
- '068938366ee0be5b70112bdf485898b4'
- '990881456a89b1ffbd68d2d7188759da'
+ r160561.patch)
+md5sums=('d0c6573f18e61d0a6c6fe742066346cd'
+ '4c5369d27b8cb4c4e447553f064d0f16'
+ '2c191ab600e600c774a65674c542e210'
+ 'a569128d6daf741b242e39f5c24debe4'
+ 'a7527896c33759ccc40bb82173f8f27f'
+ 'f9a21b9dfc174f49a09ddaacfd3ac78f'
'4030ee1c08dd1e843c0225b772360e76'
- 'bb420bc84b1104455b7230b1cd4b96c2'
- '412fb8ebb30958eb1a93e9bd89413dd7')
+ '6fd395bacbd7b6e47c7b74854b478363'
+ '79cb26e66eb2502171ef69438fa8666d')
+
+if [ -n "${_snapshot}" ]; then
+ _basedir="${srcdir}/gcc-${_snapshot}"
+else
+ _basedir="${srcdir}/gcc-${pkgver}"
+fi
build() {
- if ! locale -a | grep ^de_DE; then
+ if ! locale -a | grep ^de_DE > /dev/null; then
echo "You need the de_DE locale to build gcc."
return 1
fi
- cd ${srcdir}/gcc-${pkgver}
- #cd ${srcdir}/gcc-${_snapshot}
- # Don't install libiberty
+ cd ${_basedir}
+
+ # Do not install libiberty
sed -i 's/install_to_$(INSTALL_DEST) //' libiberty/Makefile.in
+ # Do not run fixincludes
+ sed -i 's@\./fixinc\.sh@-c true@' gcc/Makefile.in
+
if [ "${CARCH}" = "x86_64" ]; then
patch -Np1 -i ../gcc_pure64.patch || return 1
fi
patch -Np0 -i ${srcdir}/gcc-hash-style-both.patch || return 1
- patch -Np0 -i ${srcdir}/buildfix_new_bison.patch || return 1
+
+ # http://gcc.gnu.org/bugzilla/show_bug.cgi?id=44258
+ patch -Np1 -i ${srcdir}/r160561.patch || return 1
echo ${pkgver} > gcc/BASE-VER
- mkdir build
- cd build
- ../configure --prefix=/usr --enable-shared \
- --enable-languages=c,c++,fortran,objc,obj-c++,treelang \
- --enable-threads=posix --mandir=/usr/share/man --infodir=/usr/share/info \
- --enable-__cxa_atexit --disable-multilib --libdir=/usr/lib \
- --libexecdir=/usr/lib --enable-clocale=gnu --disable-libstdcxx-pch \
- --with-tune=generic
+ mkdir build && cd build
+ ../configure --prefix=/usr --enable-languages=c,c++,fortran,objc,obj-c++,ada \
+ --enable-shared --enable-threads=posix --enable-__cxa_atexit \
+ --enable-clocale=gnu --enable-gnu-unique-object \
+ --enable-lto --enable-plugin \
+ --disable-multilib --disable-libstdcxx-pch \
+ --with-system-zlib --with-ppl --with-cloog \
+ --libdir=/usr/lib --libexecdir=/usr/lib \
+ --mandir=/usr/share/man --infodir=/usr/share/info
make || return 1
+}
+
+package_gcc-libs()
+{
+ pkgdesc="Runtime libraries shipped by GCC for C and C++ languages"
+ groups=('base')
+ depends=('glibc>=2.12-4')
+ install=gcc-libs.install
+
+ cd ${_basedir}/build
+ make -j1 -C $CHOST/libgcc DESTDIR=${pkgdir} install-shared
+ for lib in libmudflap libgomp libssp libstdc++-v3/src; do
+ make -j1 -C $CHOST/$lib DESTDIR=${pkgdir} install-toolexeclibLTLIBRARIES
+ done
+ make -j1 -C $CHOST/libstdc++-v3/po DESTDIR=${pkgdir} install
+ make -j1 -C $CHOST/libgomp DESTDIR=${pkgdir} install-info
+
+ make -j1 DESTDIR=${pkgdir} install-target-libgfortran
+
+ make -j1 DESTDIR=${pkgdir} install-target-libobjc
+ # I thought I said to only install the lib...
+ rm -rf ${pkgdir}/usr/lib/gcc/
+
+ # remove static libraries
+ find ${pkgdir} -name *.a -delete
+
+ # Install Runtime Library Exception
+ install -Dm644 ${_basedir}/COPYING.RUNTIME \
+ ${pkgdir}/usr/share/licenses/gcc-libs/RUNTIME.LIBRARY.EXCEPTION
+}
+
+package_gcc()
+{
+ depends=('binutils>=2.20.1' 'libmpc>=0.8.1-2' 'cloog-ppl>=0.15.8' 'libelf')
+ groups=('base-devel')
+ install=gcc.install
+
+ cd ${_basedir}/build
+
+ # much, much easier to install the lot and clean-up the mess
make -j1 DESTDIR=${pkgdir} install || return 1
- mkdir -p ${pkgdir}/lib
- ln -sf ../usr/bin/cpp ${pkgdir}/lib/cpp
+ rm $pkgdir/usr/bin/{*gfortran,gnat*}
+ rm $pkgdir/usr/lib/gcc/$CHOST/${pkgver}/{ada{include,lib},finclude,include/objc}/*
+ rm $pkgdir/usr/lib/gcc/$CHOST/${pkgver}/{cc1obj{,plus},f951,gnat1,libgfortranbegin.a}
+ rm $pkgdir/usr/lib/{*.so*,lib{gfortran,objc}.a}
+ rm $pkgdir/usr/share/info/{gfortran,gnat*,libgomp}.info
+ rm $pkgdir/usr/share/locale/{de,fr}/LC_MESSAGES/libstdc++.mo
+ rm $pkgdir/usr/share/man/man1/gfortran.1
+
+ # many packages require these symlinks
+ install -dm755 ${pkgdir}/lib
+ ln -sf /usr/bin/cpp ${pkgdir}/lib/cpp
ln -sf gcc ${pkgdir}/usr/bin/cc
ln -sf g++ ${pkgdir}/usr/bin/c++
+ # POSIX conformance launcher scripts for c89 and c99
+ cat > $pkgdir/usr/bin/c89 <<"EOF"
+#!/bin/sh
+fl="-std=c89"
+for opt; do
+ case "$opt" in
+ -ansi|-std=c89|-std=iso9899:1990) fl="";;
+ -std=*) echo "`basename $0` called with non ANSI/ISO C option $opt" >&2
+ exit 1;;
+ esac
+done
+exec gcc $fl ${1+"$@"}
+EOF
+
+ cat > $pkgdir/usr/bin/c99 <<"EOF"
+#!/bin/sh
+fl="-std=c99"
+for opt; do
+ case "$opt" in
+ -std=c99|-std=iso9899:1999) fl="";;
+ -std=*) echo "`basename $0` called with non ISO C99 option $opt" >&2
+ exit 1;;
+ esac
+done
+exec gcc $fl ${1+"$@"}
+EOF
+
+ chmod 755 $pkgdir/usr/bin/c{8,9}9
+
# install the libstdc++ man pages
- mkdir -p ${pkgdir}/usr/share/man/man3
- install -m644 ${srcdir}/man/man3/* ${pkgdir}/usr/share/man/man3/
+ install -dm755 ${pkgdir}/usr/share/man/man3
+ install -m644 ${srcdir}/libstdc++-man.${_libstdcppmanver}/man3/* \
+ ${pkgdir}/usr/share/man/man3/
+ # deal with conflicts...
+ rm -f ${pkgdir}/usr/share/man/man3/{ctime,queue,random,regex,string}.3
+
+ # Install Runtime Library Exception
+ install -Dm644 ${_basedir}/COPYING.RUNTIME \
+ ${pkgdir}/usr/share/licenses/gcc/RUNTIME.LIBRARY.EXCEPTION
+}
+
+package_gcc-fortran()
+{
+ pkgdesc="Fortran front-end for GCC"
+ depends=("gcc=$pkgver-$pkgrel")
+ install=gcc-fortran.install
+
+ cd ${_basedir}/build
+ make -j1 DESTDIR=$pkgdir install-target-libgfortran
+ make -j1 -C $CHOST/libgomp DESTDIR=$pkgdir install-nodist_fincludeHEADERS
+ make -j1 -C gcc DESTDIR=$pkgdir fortran.install-{common,man,info}
+ install -Dm755 gcc/f951 $pkgdir/usr/lib/gcc/$CHOST/$pkgver/f951
+
+ # remove libraries included in gcc-libs
+ rm -f ${pkgdir}/usr/lib/libgfortran.so*
+
+ # Install Runtime Library Exception
+ install -Dm644 ${_basedir}/COPYING.RUNTIME \
+ ${pkgdir}/usr/share/licenses/gcc-fortran/RUNTIME.LIBRARY.EXCEPTION
+}
+
+package_gcc-objc()
+{
+ pkgdesc="Objective-C front-end for GCC"
+ depends=("gcc=$pkgver-$pkgrel")
- # Remove libraries and translations in gcc-libs
- rm -f ${pkgdir}/usr/lib/lib*
- find ${pkgdir} -name libstdc++.mo -delete
+ cd ${_basedir}/build
+ make -j1 DESTDIR=$pkgdir install-target-libobjc
+ install -dm755 $pkgdir/usr/lib/gcc/$CHOST/$pkgver/
+ install -m755 gcc/cc1obj{,plus} $pkgdir/usr/lib/gcc/$CHOST/$pkgver/
- # Remove fixed includes, either no need for them, or they're not complete
- rm -rf ${pkgdir}/usr/lib/${CHOST}/${pkgver}/include-fixed/*
+ # remove libraries included in gcc-libs
+ rm -f ${pkgdir}/usr/lib/libobjc.so*
- rm -f ${pkgdir}/usr/share/info/dir
+ # Install Runtime Library Exception
+ install -Dm644 ${_basedir}/COPYING.RUNTIME \
+ ${pkgdir}/usr/share/licenses/gcc-objc/RUNTIME.LIBRARY.EXCEPTION
+}
+
+package_gcc-ada()
+{
+ pkgdesc="Ada front-end for GCC (GNAT)"
+ depends=("gcc=$pkgver-$pkgrel")
+ install=gcc-ada.install
+
+ cd ${_basedir}/build/gcc
+ make -j1 DESTDIR=$pkgdir ada.install-{common,info}
+ install -m755 gnat1 $pkgdir/usr/lib/gcc/$CHOST/$pkgver
+
+ # Install Runtime Library Exception
+ install -Dm644 ${_basedir}/COPYING.RUNTIME \
+ ${pkgdir}/usr/share/licenses/gcc-ada/RUNTIME.LIBRARY.EXCEPTION
}
diff --git a/abs/core-testing/gcc/gcc-ada.install b/abs/core-testing/gcc/gcc-ada.install
new file mode 100644
index 0000000..1c8e086
--- /dev/null
+++ b/abs/core-testing/gcc/gcc-ada.install
@@ -0,0 +1,22 @@
+infodir=/usr/share/info
+filelist=(gnat-style.info gnat_rm.info gnat_ugn.info)
+
+post_install() {
+ [ -x usr/bin/install-info ] || return 0
+ for file in ${filelist[@]}; do
+ install-info $infodir/$file.gz $infodir/dir 2> /dev/null
+ done
+}
+
+post_upgrade() {
+ post_install $1
+}
+
+pre_remove() {
+ [ -x usr/bin/install-info ] || return 0
+ for file in ${filelist[@]}; do
+ install-info --delete $infodir/$file.gz $infodir/dir 2> /dev/null
+ done
+}
+
+# vim:set ts=2 sw=2 et:
diff --git a/abs/core-testing/gcc/gcc-fortran.install b/abs/core-testing/gcc/gcc-fortran.install
new file mode 100644
index 0000000..acffc05
--- /dev/null
+++ b/abs/core-testing/gcc/gcc-fortran.install
@@ -0,0 +1,18 @@
+infodir=/usr/share/info
+file="gfortran.info"
+
+post_install() {
+ [ -x usr/bin/install-info ] || return 0
+ install-info $infodir/$file.gz $infodir/dir 2> /dev/null
+}
+
+post_upgrade() {
+ post_install $1
+}
+
+pre_remove() {
+ [ -x usr/bin/install-info ] || return 0
+ install-info --delete $infodir/$file.gz $infodir/dir 2> /dev/null
+}
+
+# vim:set ts=2 sw=2 et:
diff --git a/abs/core-testing/gcc/gcc-hash-style-both.patch b/abs/core-testing/gcc/gcc-hash-style-both.patch
index 8fea758..fbb2105 100644
--- a/abs/core-testing/gcc/gcc-hash-style-both.patch
+++ b/abs/core-testing/gcc/gcc-hash-style-both.patch
@@ -78,8 +78,8 @@ exit 0
{ "link_arch_default", LINK_ARCH_DEFAULT_SPEC }, \
{ "link_arch", LINK_ARCH_SPEC },
--#define LINK_ARCH32_SPEC "-m elf32_sparc -Y P,/usr/lib %{shared:-shared} \
-+#define LINK_ARCH32_SPEC "-m elf32_sparc --hash-style=both -Y P,/usr/lib %{shared:-shared} \
+-#define LINK_ARCH32_SPEC "-m elf32_sparc -Y P,%R/usr/lib %{shared:-shared} \
++#define LINK_ARCH32_SPEC "-m elf32_sparc --hash-style=both -Y P,%R/usr/lib %{shared:-shared} \
%{!shared: \
%{!ibcs: \
%{!static: \
@@ -87,8 +87,8 @@ exit 0
%{static:-static}}} \
"
--#define LINK_ARCH64_SPEC "-m elf64_sparc -Y P,/usr/lib64 %{shared:-shared} \
-+#define LINK_ARCH64_SPEC "-m elf64_sparc --hash-style=both -Y P,/usr/lib64 %{shared:-shared} \
+-#define LINK_ARCH64_SPEC "-m elf64_sparc -Y P,%R/usr/lib64 %{shared:-shared} \
++#define LINK_ARCH64_SPEC "-m elf64_sparc --hash-style=both -Y P,%R/usr/lib64 %{shared:-shared} \
%{!shared: \
%{!ibcs: \
%{!static: \
@@ -96,8 +96,8 @@ exit 0
#else /* !SPARC_BI_ARCH */
#undef LINK_SPEC
--#define LINK_SPEC "-m elf64_sparc -Y P,/usr/lib64 %{shared:-shared} \
-+#define LINK_SPEC "-m elf64_sparc --hash-style=both -Y P,/usr/lib64 %{shared:-shared} \
+-#define LINK_SPEC "-m elf64_sparc -Y P,%R/usr/lib64 %{shared:-shared} \
++#define LINK_SPEC "-m elf64_sparc --hash-style=both -Y P,%R/usr/lib64 %{shared:-shared} \
%{!shared: \
%{!ibcs: \
%{!static: \
diff --git a/abs/core-testing/gcc/gcc-libs.install b/abs/core-testing/gcc/gcc-libs.install
new file mode 100644
index 0000000..bd57efb
--- /dev/null
+++ b/abs/core-testing/gcc/gcc-libs.install
@@ -0,0 +1,14 @@
+infodir=/usr/share/info
+file="libgomp.info"
+
+post_upgrade() {
+ [ -x usr/bin/install-info ] || return 0
+ install-info $infodir/$file.gz $infodir/dir 2> /dev/null
+}
+
+pre_remove() {
+ [ -x usr/bin/install-info ] || return 0
+ install-info --delete $infodir/$file.gz $infodir/dir 2> /dev/null
+}
+
+# vim:set ts=2 sw=2 et:
diff --git a/abs/core-testing/gcc/gcc.install b/abs/core-testing/gcc/gcc.install
index 1ad170c..83d89b0 100644
--- a/abs/core-testing/gcc/gcc.install
+++ b/abs/core-testing/gcc/gcc.install
@@ -1,9 +1,10 @@
infodir=/usr/share/info
-filelist=(cpp.info cppinternals.info gcc.info gccinstall.info gccint.info gfortran.info libgomb.info treelang.info)
+filelist=(cpp.info cppinternals.info gcc.info gccinstall.info gccint.info)
post_install() {
+ [ -x usr/bin/install-info ] || return 0
for file in ${filelist[@]}; do
- install-info $infodir/$file $infodir/dir 2> /dev/null
+ install-info $infodir/$file.gz $infodir/dir 2> /dev/null
done
}
@@ -12,8 +13,9 @@ post_upgrade() {
}
pre_remove() {
+ [ -x usr/bin/install-info ] || return 0
for file in ${filelist[@]}; do
- install-info --delete $infodir/$file $infodir/dir 2> /dev/null
+ install-info --delete $infodir/$file.gz $infodir/dir 2> /dev/null
done
}
diff --git a/abs/core-testing/gcc/r160561.patch b/abs/core-testing/gcc/r160561.patch
new file mode 100644
index 0000000..f3c386b
--- /dev/null
+++ b/abs/core-testing/gcc/r160561.patch
@@ -0,0 +1,64 @@
+--- trunk/gcc/tree-sra.c 2010/06/10 16:44:04 160560
++++ trunk/gcc/tree-sra.c 2010/06/10 16:49:09 160561
+@@ -1689,9 +1689,10 @@
+
+ /* Build a subtree of accesses rooted in *ACCESS, and move the pointer in the
+ linked list along the way. Stop when *ACCESS is NULL or the access pointed
+- to it is not "within" the root. */
++ to it is not "within" the root. Return false iff some accesses partially
++ overlap. */
+
+-static void
++static bool
+ build_access_subtree (struct access **access)
+ {
+ struct access *root = *access, *last_child = NULL;
+@@ -1706,24 +1707,32 @@
+ last_child->next_sibling = *access;
+ last_child = *access;
+
+- build_access_subtree (access);
++ if (!build_access_subtree (access))
++ return false;
+ }
++
++ if (*access && (*access)->offset < limit)
++ return false;
++
++ return true;
+ }
+
+ /* Build a tree of access representatives, ACCESS is the pointer to the first
+- one, others are linked in a list by the next_grp field. Decide about scalar
+- replacements on the way, return true iff any are to be created. */
++ one, others are linked in a list by the next_grp field. Return false iff
++ some accesses partially overlap. */
+
+-static void
++static bool
+ build_access_trees (struct access *access)
+ {
+ while (access)
+ {
+ struct access *root = access;
+
+- build_access_subtree (&access);
++ if (!build_access_subtree (&access))
++ return false;
+ root->next_grp = access;
+ }
++ return true;
+ }
+
+ /* Return true if expr contains some ARRAY_REFs into a variable bounded
+@@ -2062,9 +2071,7 @@
+ struct access *access;
+
+ access = sort_and_splice_var_accesses (var);
+- if (access)
+- build_access_trees (access);
+- else
++ if (!access || !build_access_trees (access))
+ disqualify_candidate (var,
+ "No or inhibitingly overlapping accesses.");
+ }